# coding: utf-8

"""
    Pathnexus

    Pathnexus - a lab data harmonisation platform  # noqa: E501

    OpenAPI spec version: 5.8.0
    Contact: support@termlex.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from pathnexus.com.termlex.pathnexus.model.enumeration_name_use import EnumerationNameUse  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.extension import Extension  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.period import Period  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.string_type import StringType  # noqa: F401,E501


class HumanName(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'format_comments_pre': 'list[str]',
        'format_comments_post': 'list[str]',
        'id': 'str',
        'extension': 'list[Extension]',
        'disallow_extensions': 'bool',
        'use': 'str',
        'text': 'str',
        'family': 'str',
        'given': 'list[StringType]',
        'prefix': 'list[StringType]',
        'suffix': 'list[StringType]',
        'period': 'Period',
        'text_element': 'StringType',
        'use_element': 'EnumerationNameUse',
        'family_element': 'StringType',
        'given_as_single_string': 'str',
        'prefix_as_single_string': 'str',
        'suffix_as_single_string': 'str',
        'name_as_single_string': 'str',
        'empty': 'bool',
        'id_element': 'StringType',
        'extension_first_rep': 'Extension',
        'id_base': 'str',
        'resource': 'bool',
        'boolean_primitive': 'bool',
        'date_time': 'bool',
        'primitive': 'bool'
    }

    attribute_map = {
        'format_comments_pre': 'formatCommentsPre',
        'format_comments_post': 'formatCommentsPost',
        'id': 'id',
        'extension': 'extension',
        'disallow_extensions': 'disallowExtensions',
        'use': 'use',
        'text': 'text',
        'family': 'family',
        'given': 'given',
        'prefix': 'prefix',
        'suffix': 'suffix',
        'period': 'period',
        'text_element': 'textElement',
        'use_element': 'useElement',
        'family_element': 'familyElement',
        'given_as_single_string': 'givenAsSingleString',
        'prefix_as_single_string': 'prefixAsSingleString',
        'suffix_as_single_string': 'suffixAsSingleString',
        'name_as_single_string': 'nameAsSingleString',
        'empty': 'empty',
        'id_element': 'idElement',
        'extension_first_rep': 'extensionFirstRep',
        'id_base': 'idBase',
        'resource': 'resource',
        'boolean_primitive': 'booleanPrimitive',
        'date_time': 'dateTime',
        'primitive': 'primitive'
    }

    def __init__(self, format_comments_pre=None, format_comments_post=None, id=None, extension=None, disallow_extensions=None, use=None, text=None, family=None, given=None, prefix=None, suffix=None, period=None, text_element=None, use_element=None, family_element=None, given_as_single_string=None, prefix_as_single_string=None, suffix_as_single_string=None, name_as_single_string=None, empty=None, id_element=None, extension_first_rep=None, id_base=None, resource=None, boolean_primitive=None, date_time=None, primitive=None):  # noqa: E501
        """HumanName - a model defined in Swagger"""  # noqa: E501

        self._format_comments_pre = None
        self._format_comments_post = None
        self._id = None
        self._extension = None
        self._disallow_extensions = None
        self._use = None
        self._text = None
        self._family = None
        self._given = None
        self._prefix = None
        self._suffix = None
        self._period = None
        self._text_element = None
        self._use_element = None
        self._family_element = None
        self._given_as_single_string = None
        self._prefix_as_single_string = None
        self._suffix_as_single_string = None
        self._name_as_single_string = None
        self._empty = None
        self._id_element = None
        self._extension_first_rep = None
        self._id_base = None
        self._resource = None
        self._boolean_primitive = None
        self._date_time = None
        self._primitive = None
        self.discriminator = None

        if format_comments_pre is not None:
            self.format_comments_pre = format_comments_pre
        if format_comments_post is not None:
            self.format_comments_post = format_comments_post
        if id is not None:
            self.id = id
        if extension is not None:
            self.extension = extension
        if disallow_extensions is not None:
            self.disallow_extensions = disallow_extensions
        if use is not None:
            self.use = use
        if text is not None:
            self.text = text
        if family is not None:
            self.family = family
        if given is not None:
            self.given = given
        if prefix is not None:
            self.prefix = prefix
        if suffix is not None:
            self.suffix = suffix
        if period is not None:
            self.period = period
        if text_element is not None:
            self.text_element = text_element
        if use_element is not None:
            self.use_element = use_element
        if family_element is not None:
            self.family_element = family_element
        if given_as_single_string is not None:
            self.given_as_single_string = given_as_single_string
        if prefix_as_single_string is not None:
            self.prefix_as_single_string = prefix_as_single_string
        if suffix_as_single_string is not None:
            self.suffix_as_single_string = suffix_as_single_string
        if name_as_single_string is not None:
            self.name_as_single_string = name_as_single_string
        if empty is not None:
            self.empty = empty
        if id_element is not None:
            self.id_element = id_element
        if extension_first_rep is not None:
            self.extension_first_rep = extension_first_rep
        if id_base is not None:
            self.id_base = id_base
        if resource is not None:
            self.resource = resource
        if boolean_primitive is not None:
            self.boolean_primitive = boolean_primitive
        if date_time is not None:
            self.date_time = date_time
        if primitive is not None:
            self.primitive = primitive

    @property
    def format_comments_pre(self):
        """Gets the format_comments_pre of this HumanName.  # noqa: E501


        :return: The format_comments_pre of this HumanName.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_pre

    @format_comments_pre.setter
    def format_comments_pre(self, format_comments_pre):
        """Sets the format_comments_pre of this HumanName.


        :param format_comments_pre: The format_comments_pre of this HumanName.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_pre = format_comments_pre

    @property
    def format_comments_post(self):
        """Gets the format_comments_post of this HumanName.  # noqa: E501


        :return: The format_comments_post of this HumanName.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_post

    @format_comments_post.setter
    def format_comments_post(self, format_comments_post):
        """Sets the format_comments_post of this HumanName.


        :param format_comments_post: The format_comments_post of this HumanName.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_post = format_comments_post

    @property
    def id(self):
        """Gets the id of this HumanName.  # noqa: E501


        :return: The id of this HumanName.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this HumanName.


        :param id: The id of this HumanName.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def extension(self):
        """Gets the extension of this HumanName.  # noqa: E501


        :return: The extension of this HumanName.  # noqa: E501
        :rtype: list[Extension]
        """
        return self._extension

    @extension.setter
    def extension(self, extension):
        """Sets the extension of this HumanName.


        :param extension: The extension of this HumanName.  # noqa: E501
        :type: list[Extension]
        """

        self._extension = extension

    @property
    def disallow_extensions(self):
        """Gets the disallow_extensions of this HumanName.  # noqa: E501


        :return: The disallow_extensions of this HumanName.  # noqa: E501
        :rtype: bool
        """
        return self._disallow_extensions

    @disallow_extensions.setter
    def disallow_extensions(self, disallow_extensions):
        """Sets the disallow_extensions of this HumanName.


        :param disallow_extensions: The disallow_extensions of this HumanName.  # noqa: E501
        :type: bool
        """

        self._disallow_extensions = disallow_extensions

    @property
    def use(self):
        """Gets the use of this HumanName.  # noqa: E501


        :return: The use of this HumanName.  # noqa: E501
        :rtype: str
        """
        return self._use

    @use.setter
    def use(self, use):
        """Sets the use of this HumanName.


        :param use: The use of this HumanName.  # noqa: E501
        :type: str
        """
        allowed_values = ["USUAL", "OFFICIAL", "TEMP", "NICKNAME", "ANONYMOUS", "OLD", "MAIDEN", "NULL"]  # noqa: E501
        if use not in allowed_values:
            raise ValueError(
                "Invalid value for `use` ({0}), must be one of {1}"  # noqa: E501
                .format(use, allowed_values)
            )

        self._use = use

    @property
    def text(self):
        """Gets the text of this HumanName.  # noqa: E501


        :return: The text of this HumanName.  # noqa: E501
        :rtype: str
        """
        return self._text

    @text.setter
    def text(self, text):
        """Sets the text of this HumanName.


        :param text: The text of this HumanName.  # noqa: E501
        :type: str
        """

        self._text = text

    @property
    def family(self):
        """Gets the family of this HumanName.  # noqa: E501


        :return: The family of this HumanName.  # noqa: E501
        :rtype: str
        """
        return self._family

    @family.setter
    def family(self, family):
        """Sets the family of this HumanName.


        :param family: The family of this HumanName.  # noqa: E501
        :type: str
        """

        self._family = family

    @property
    def given(self):
        """Gets the given of this HumanName.  # noqa: E501


        :return: The given of this HumanName.  # noqa: E501
        :rtype: list[StringType]
        """
        return self._given

    @given.setter
    def given(self, given):
        """Sets the given of this HumanName.


        :param given: The given of this HumanName.  # noqa: E501
        :type: list[StringType]
        """

        self._given = given

    @property
    def prefix(self):
        """Gets the prefix of this HumanName.  # noqa: E501


        :return: The prefix of this HumanName.  # noqa: E501
        :rtype: list[StringType]
        """
        return self._prefix

    @prefix.setter
    def prefix(self, prefix):
        """Sets the prefix of this HumanName.


        :param prefix: The prefix of this HumanName.  # noqa: E501
        :type: list[StringType]
        """

        self._prefix = prefix

    @property
    def suffix(self):
        """Gets the suffix of this HumanName.  # noqa: E501


        :return: The suffix of this HumanName.  # noqa: E501
        :rtype: list[StringType]
        """
        return self._suffix

    @suffix.setter
    def suffix(self, suffix):
        """Sets the suffix of this HumanName.


        :param suffix: The suffix of this HumanName.  # noqa: E501
        :type: list[StringType]
        """

        self._suffix = suffix

    @property
    def period(self):
        """Gets the period of this HumanName.  # noqa: E501


        :return: The period of this HumanName.  # noqa: E501
        :rtype: Period
        """
        return self._period

    @period.setter
    def period(self, period):
        """Sets the period of this HumanName.


        :param period: The period of this HumanName.  # noqa: E501
        :type: Period
        """

        self._period = period

    @property
    def text_element(self):
        """Gets the text_element of this HumanName.  # noqa: E501


        :return: The text_element of this HumanName.  # noqa: E501
        :rtype: StringType
        """
        return self._text_element

    @text_element.setter
    def text_element(self, text_element):
        """Sets the text_element of this HumanName.


        :param text_element: The text_element of this HumanName.  # noqa: E501
        :type: StringType
        """

        self._text_element = text_element

    @property
    def use_element(self):
        """Gets the use_element of this HumanName.  # noqa: E501


        :return: The use_element of this HumanName.  # noqa: E501
        :rtype: EnumerationNameUse
        """
        return self._use_element

    @use_element.setter
    def use_element(self, use_element):
        """Sets the use_element of this HumanName.


        :param use_element: The use_element of this HumanName.  # noqa: E501
        :type: EnumerationNameUse
        """

        self._use_element = use_element

    @property
    def family_element(self):
        """Gets the family_element of this HumanName.  # noqa: E501


        :return: The family_element of this HumanName.  # noqa: E501
        :rtype: StringType
        """
        return self._family_element

    @family_element.setter
    def family_element(self, family_element):
        """Sets the family_element of this HumanName.


        :param family_element: The family_element of this HumanName.  # noqa: E501
        :type: StringType
        """

        self._family_element = family_element

    @property
    def given_as_single_string(self):
        """Gets the given_as_single_string of this HumanName.  # noqa: E501


        :return: The given_as_single_string of this HumanName.  # noqa: E501
        :rtype: str
        """
        return self._given_as_single_string

    @given_as_single_string.setter
    def given_as_single_string(self, given_as_single_string):
        """Sets the given_as_single_string of this HumanName.


        :param given_as_single_string: The given_as_single_string of this HumanName.  # noqa: E501
        :type: str
        """

        self._given_as_single_string = given_as_single_string

    @property
    def prefix_as_single_string(self):
        """Gets the prefix_as_single_string of this HumanName.  # noqa: E501


        :return: The prefix_as_single_string of this HumanName.  # noqa: E501
        :rtype: str
        """
        return self._prefix_as_single_string

    @prefix_as_single_string.setter
    def prefix_as_single_string(self, prefix_as_single_string):
        """Sets the prefix_as_single_string of this HumanName.


        :param prefix_as_single_string: The prefix_as_single_string of this HumanName.  # noqa: E501
        :type: str
        """

        self._prefix_as_single_string = prefix_as_single_string

    @property
    def suffix_as_single_string(self):
        """Gets the suffix_as_single_string of this HumanName.  # noqa: E501


        :return: The suffix_as_single_string of this HumanName.  # noqa: E501
        :rtype: str
        """
        return self._suffix_as_single_string

    @suffix_as_single_string.setter
    def suffix_as_single_string(self, suffix_as_single_string):
        """Sets the suffix_as_single_string of this HumanName.


        :param suffix_as_single_string: The suffix_as_single_string of this HumanName.  # noqa: E501
        :type: str
        """

        self._suffix_as_single_string = suffix_as_single_string

    @property
    def name_as_single_string(self):
        """Gets the name_as_single_string of this HumanName.  # noqa: E501


        :return: The name_as_single_string of this HumanName.  # noqa: E501
        :rtype: str
        """
        return self._name_as_single_string

    @name_as_single_string.setter
    def name_as_single_string(self, name_as_single_string):
        """Sets the name_as_single_string of this HumanName.


        :param name_as_single_string: The name_as_single_string of this HumanName.  # noqa: E501
        :type: str
        """

        self._name_as_single_string = name_as_single_string

    @property
    def empty(self):
        """Gets the empty of this HumanName.  # noqa: E501


        :return: The empty of this HumanName.  # noqa: E501
        :rtype: bool
        """
        return self._empty

    @empty.setter
    def empty(self, empty):
        """Sets the empty of this HumanName.


        :param empty: The empty of this HumanName.  # noqa: E501
        :type: bool
        """

        self._empty = empty

    @property
    def id_element(self):
        """Gets the id_element of this HumanName.  # noqa: E501


        :return: The id_element of this HumanName.  # noqa: E501
        :rtype: StringType
        """
        return self._id_element

    @id_element.setter
    def id_element(self, id_element):
        """Sets the id_element of this HumanName.


        :param id_element: The id_element of this HumanName.  # noqa: E501
        :type: StringType
        """

        self._id_element = id_element

    @property
    def extension_first_rep(self):
        """Gets the extension_first_rep of this HumanName.  # noqa: E501


        :return: The extension_first_rep of this HumanName.  # noqa: E501
        :rtype: Extension
        """
        return self._extension_first_rep

    @extension_first_rep.setter
    def extension_first_rep(self, extension_first_rep):
        """Sets the extension_first_rep of this HumanName.


        :param extension_first_rep: The extension_first_rep of this HumanName.  # noqa: E501
        :type: Extension
        """

        self._extension_first_rep = extension_first_rep

    @property
    def id_base(self):
        """Gets the id_base of this HumanName.  # noqa: E501


        :return: The id_base of this HumanName.  # noqa: E501
        :rtype: str
        """
        return self._id_base

    @id_base.setter
    def id_base(self, id_base):
        """Sets the id_base of this HumanName.


        :param id_base: The id_base of this HumanName.  # noqa: E501
        :type: str
        """

        self._id_base = id_base

    @property
    def resource(self):
        """Gets the resource of this HumanName.  # noqa: E501


        :return: The resource of this HumanName.  # noqa: E501
        :rtype: bool
        """
        return self._resource

    @resource.setter
    def resource(self, resource):
        """Sets the resource of this HumanName.


        :param resource: The resource of this HumanName.  # noqa: E501
        :type: bool
        """

        self._resource = resource

    @property
    def boolean_primitive(self):
        """Gets the boolean_primitive of this HumanName.  # noqa: E501


        :return: The boolean_primitive of this HumanName.  # noqa: E501
        :rtype: bool
        """
        return self._boolean_primitive

    @boolean_primitive.setter
    def boolean_primitive(self, boolean_primitive):
        """Sets the boolean_primitive of this HumanName.


        :param boolean_primitive: The boolean_primitive of this HumanName.  # noqa: E501
        :type: bool
        """

        self._boolean_primitive = boolean_primitive

    @property
    def date_time(self):
        """Gets the date_time of this HumanName.  # noqa: E501


        :return: The date_time of this HumanName.  # noqa: E501
        :rtype: bool
        """
        return self._date_time

    @date_time.setter
    def date_time(self, date_time):
        """Sets the date_time of this HumanName.


        :param date_time: The date_time of this HumanName.  # noqa: E501
        :type: bool
        """

        self._date_time = date_time

    @property
    def primitive(self):
        """Gets the primitive of this HumanName.  # noqa: E501


        :return: The primitive of this HumanName.  # noqa: E501
        :rtype: bool
        """
        return self._primitive

    @primitive.setter
    def primitive(self, primitive):
        """Sets the primitive of this HumanName.


        :param primitive: The primitive of this HumanName.  # noqa: E501
        :type: bool
        """

        self._primitive = primitive

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, HumanName):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
